## gargoyle-free 2026.1.1+dfsg

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12)

file(READ "VERSION" GARGOYLE_VERSION)
string(STRIP "${GARGOYLE_VERSION}" GARGOYLE_VERSION)

# Don't set a version here: CMake requires a version of the form
# <major>[.<minor>[.<patch>[.<tweak>]]]
# where all parts are non-negative integers. This doesn't work with
# CI builds which include the current Git revision as the version.
project(garglk)

if(POLICY CMP0069)
    cmake_policy(SET CMP0069 NEW)
    include(CheckIPOSupported)
    check_ipo_supported(RESULT HAS_LTO)
endif()

if(CMAKE_CXX_COMPILER_ID STREQUAL "GNU" AND CMAKE_CXX_COMPILER_VERSION VERSION_LESS "9")
    set(GARGLK_NO_CXX17 TRUE)
endif()

# Darwin 19.0 corresponds to MacOS 10.15.
if(APPLE AND CMAKE_SYSTEM_VERSION VERSION_LESS 19.0)
    set(GARGLK_NO_CXX17 TRUE)
endif()

# At the moment C++17 is optional, but it will likely be required in the
# near future. MacOS introduced C++17 support in 10.15, so use C++14 for
# any earlier versions.
# In addition, CMake claims C++17 support for g++7, but std::filesystem
# isn't available there. In fact, proper std::filesystem support didn't
# land in gcc till version 9 (see https://gcc.gnu.org/gcc-9/changes.html),
# so disable on gcc versions prior to 9.
if("cxx_std_17" IN_LIST CMAKE_CXX_COMPILE_FEATURES AND NOT GARGLK_NO_CXX17)
    set(CXX_VERSION 17)
else()
    set(CXX_VERSION 14)
endif()

list(APPEND CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake/Modules/")

include(Compilers)

option(WITH_INTERPRETERS "Build the included interpreters" ON)
option(WITH_BABEL "Display Treaty of Babel-derived author and title if possible" ON)
option(APPIMAGE "Tweak some settings to aid in AppImage building" OFF)

if(MSVC)
    # MSVC defaults to the equivalent of "-fvisibility=hidden", which the code is not set up to support.
    set(CMAKE_WINDOWS_EXPORT_ALL_SYMBOLS ON)
    include_directories("win32compat")
    add_compile_definitions("_CRT_SECURE_NO_WARNINGS")
    if(CMAKE_CXX_COMPILER_ID MATCHES "Clang")
        add_compile_options("-Wno-everything" "-Wall" "-Wextra" "-ferror-limit=100")
    endif()
endif()

if(APPLE)
    option(DIST_INSTALL "Install to ${PROJECT_SOURCE_DIR}/build/dist for packaging" OFF)
elseif(MINGW)
    set(DIST_INSTALL ON)
endif()

if(UNIX AND NOT DIST_INSTALL)
    include(GNUInstallDirs)
    if(APPIMAGE)
        set(INTERPRETER_INSTALL_DIR "${CMAKE_INSTALL_FULL_BINDIR}")
    else()
        set(INTERPRETER_INSTALL_DIR "${CMAKE_INSTALL_FULL_LIBEXECDIR}/gargoyle")
    endif()
endif()

option(WITH_FRANKENDRIFT "Build the FrankenDrift interpreter for ADRIFT 5 games (requires the .NET 8 SDK)" OFF)
add_subdirectory(garglk)

# xBRZ requires C++17.
if(CXX_VERSION EQUAL 17)
    add_subdirectory(support/xbrz)
    add_subdirectory(support/xbrz-null)
    add_subdirectory(support/hqx)
endif()

if(WITH_INTERPRETERS)
    add_subdirectory(terps)
endif()

if(WITH_BABEL)
    add_subdirectory(support/babel)
endif()

include(FeatureSummary)
add_feature_info(FrankenDrift WITH_FRANKENDRIFT "the FrankenDrift interpreter for ADRIFT 5 games")
feature_summary(WHAT ALL)

=== garglk/CMakeLists.txt ===
include(vtkEncodeString)

configure_file("garversion.h.in" "${CMAKE_CURRENT_LIST_DIR}/garversion.h")

option(WITH_LAUNCHER "Build the launcher (i.e. the gargoyle executable)" ON)
option(BUILD_SHARED_LIBS "Build a shared libgarglk instead of a static library" ON)
option(WITH_BUNDLED_FMT "Use Gargoyle's bundled fmt library instead of the system's fmt library" OFF)

if(UNIX AND NOT APPLE)
    option(WITH_FREEDESKTOP "Install freedesktop.org application, icon, and MIME files" ON)
    set(GARGLKINI "${CMAKE_INSTALL_FULL_SYSCONFDIR}/garglk.ini")
    if(NOT APPIMAGE)
        option(INSTALL_GARGLKINI "Install an example config file to ${GARGLKINI}" OFF)
    endif()
    option(INSTALL_DEV "Install development files (headers, pkg-config file)" OFF)
endif()

if(APPLE)
    set(INTERFACE "COCOA" CACHE STRING "Interface to use (COCOA or QT)")
else()
    set(INTERFACE "QT")
endif()

set(WITH_TTS "AUTO" CACHE STRING "Enable text-to-speech support (ON/OFF/AUTO/DYNAMIC)")
set(GARGLKPRE "" CACHE STRING "Binary prefix")
set(SOUND "SDL" CACHE STRING "Backend to use for sound (SDL, QT, or NONE)")
set(JPEGLIB "AUTO" CACHE STRING "JPEG library to use (TURBO, IJG, or AUTO)")

if(INTERFACE STREQUAL "QT")
    option(WITH_NATIVE_FILE_DIALOGS "Use native dialogs instead of Qt dialogs" ON)
endif()

if(SOUND STREQUAL "SDL" OR SOUND STREQUAL "QT")
    set(DEFAULT_SOUNDFONT "" CACHE STRING "Path to a soundfont to use by default (defaults to empty, i.e. no default soundfont)")
endif()

if(MSVC)
    vtk_encode_string(
        INPUT garglk.ini
        NAME garglkini
        HEADER_OUTPUT GARGLKINI_H
        SOURCE_OUTPUT GARGLKINI_CXX
        EXPORT_SYMBOL "GARGLK_API"
        EXPORT_HEADER "garglk_importexport.h"
    )
else()
    vtk_encode_string(
        INPUT garglk.ini
        NAME garglkini
        HEADER_OUTPUT GARGLKINI_H
        SOURCE_OUTPUT GARGLKINI_CXX
    )
endif()

set_property(SOURCE config.cpp launchqt.cpp APPEND PROPERTY COMPILE_DEFINITIONS GARGLKINI_H="${GARGLKINI_H}")

vtk_encode_string(
    INPUT ../themes/dark.json
    NAME theme_dark
    HEADER_OUTPUT THEME_DARK_H
    SOURCE_OUTPUT THEME_DARK_CXX
)

vtk_encode_string(
    INPUT ../themes/light.json
    NAME theme_light
    HEADER_OUTPUT THEME_LIGHT_H
    SOURCE_OUTPUT THEME_LIGHT_CXX
)

set_property(SOURCE theme.cpp APPEND PROPERTY COMPILE_DEFINITIONS THEME_DARK_H="${THEME_DARK_H}" THEME_LIGHT_H="${THEME_LIGHT_H}")

if(INTERFACE STREQUAL "QT")
    set(CMAKE_AUTOMOC ON)
    set_property(SOURCE ${GARGLKINI_CXX} ${THEME_DARK_CXX} ${THEME_DARK_H} ${THEME_LIGHT_CXX} ${THEME_LIGHT_H} PROPERTY SKIP_AUTOMOC ON)

    if(NOT WITH_NATIVE_FILE_DIALOGS)
        set_property(SOURCE sysqt.cpp launchqt.cpp APPEND PROPERTY COMPILE_DEFINITIONS GARGLK_CONFIG_NO_NATIVE_FILE_DIALOGS)
    endif()
endif()

add_library(garglk-common OBJECT babeldata.cpp style.cpp config.cpp draw.cpp event.cpp
    garglk.cpp imgload.cpp imgscale.cpp theme.cpp winblank.cpp window.cpp
    wingfx.cpp wingrid.cpp winmask.cpp winpair.cpp wintext.cpp zbleep.cpp
    ${GARGLKINI_CXX} ${THEME_DARK_CXX} ${THEME_LIGHT_CXX}

    # These can't be a library in cheapglk/ because they contain
    # references to code in garglk, and garglk contains references to
    # cheapglk (i.e. circular dependencies). That's fine with shared
    # libraries, but will fail with static libraries. These are pulled
    # from cheapglk and kept separate logically, but they're really a
    # part of garglk itself, so add them directly to the garglk target.
    cheapglk/cgblorb.cpp cheapglk/cgdate.cpp cheapglk/cgfref.cpp
    cheapglk/cggestal.cpp cheapglk/cgmisc.cpp cheapglk/cgstream.cpp
    cheapglk/cgunicod.cpp cheapglk/gi_blorb.c cheapglk/gi_dispa.c)

set_target_properties(garglk-common PROPERTIES POSITION_INDEPENDENT_CODE TRUE)

target_include_directories(garglk-common PRIVATE .)

c_standard(garglk-common 11)
cxx_standard(garglk-common ${CXX_VERSION})
warnings(garglk-common)

if(UNIX AND NOT APPLE)
    target_compile_definitions(garglk-common PRIVATE "GARGLKINI=\"${GARGLKINI}\"")
    target_compile_definitions(garglk-common PRIVATE "GARGLK_CONFIG_DATADIR=\"${CMAKE_INSTALL_FULL_DATAROOTDIR}/gargoyle\"")
endif()

if(DEFAULT_SOUNDFONT)
    target_compile_definitions(garglk-common PRIVATE "GARGLK_DEFAULT_SOUNDFONT=\"${DEFAULT_SOUNDFONT}\"")
endif()

if(APPIMAGE)
    target_compile_definitions(garglk-common PRIVATE GARGLK_CONFIG_APPIMAGE)
endif()

if(INTERFACE STREQUAL "COCOA")
    target_sources(garglk-common PRIVATE sysmac.mm)
    target_compile_options(garglk-common PRIVATE "-Wno-deprecated-declarations")
else()
    target_sources(garglk-common PRIVATE sysqt.cpp)
    find_package(Threads REQUIRED)
    target_link_libraries(garglk-common PRIVATE ${CMAKE_THREAD_LIBS_INIT})
endif()

find_package(Freetype REQUIRED)
find_package(PNG 1.6 REQUIRED)
target_include_directories(garglk-common PUBLIC cheapglk PRIVATE ${FREETYPE_INCLUDE_DIRS} ${PNG_INCLUDE_DIRS})
target_link_libraries(garglk-common PRIVATE ${FREETYPE_LIBRARIES} ${PNG_LIBRARIES})

if(NOT WITH_BUNDLED_FMT)
    find_package(fmt CONFIG)
endif()

function(add_fmt target)
    if(TARGET fmt::fmt)
        target_link_libraries(${target} PRIVATE fmt::fmt)
    else()
        target_compile_definitions(${target} PRIVATE GARGLK_CONFIG_BUNDLED_FMT)
    endif()
endfunction()

add_fmt(garglk-common)

find_library(MATH_LIBRARY m)
if(MATH_LIBRARY)
    target_link_libraries(garglk-common PRIVATE ${MATH_LIBRARY})
endif()

add_library(garglkmain STATIC main.c)
c_standard(garglkmain 11)
warnings(garglkmain)
target_include_directories(garglkmain PRIVATE cheapglk)

# If garglk is built with PIC, do the same for garglkmain.
get_property(GARGLK_PIC TARGET garglk-common PROPERTY POSITION_INDEPENDENT_CODE)
set_target_properties(garglkmain PROPERTIES POSITION_INDEPENDENT_CODE "${GARGLK_PIC}")

if(WITH_LAUNCHER)
    add_executable(gargoyle WIN32 launcher.cpp)
    target_include_directories(gargoyle PRIVATE cheapglk)
    target_link_libraries(gargoyle PRIVATE garglk)
    add_fmt(gargoyle)
    cxx_standard(gargoyle ${CXX_VERSION})
    warnings(gargoyle)

    target_compile_definitions(gargoyle PRIVATE "GARGLKINI=\"${GARGLKINI}\"" "GARGLKPRE=\"${GARGLKPRE}\"")
    if(WITH_FRANKENDRIFT)
        target_compile_definitions(gargoyle PRIVATE WITH_FRANKENDRIFT=1)
    endif()
    if(${INTERFACE} STREQUAL "COCOA")
        target_sources(gargoyle PRIVATE launchmac.mm)
        target_compile_options(gargoyle PRIVATE "-Wno-deprecated-declarations")
    else()
        target_sources(gargoyle PRIVATE launchqt.cpp)

        # For AppImage, interpreters are installed in the same directory as the
        # launcher, so don't provide GARGLK_CONFIG_INTERPRETER_DIR: in its
        # absence, the directory of the "gargoyle" binary is searched.
        #
        # For Apple, when doing a dist install, the same holds: it expects to
        # find interpreters in the same directory as the gargoyle binary.
        if(UNIX AND NOT APPIMAGE AND NOT DIST_INSTALL)
            target_compile_definitions(gargoyle PRIVATE "GARGLK_CONFIG_INTERPRETER_DIR=\"${INTERPRETER_INSTALL_DIR}\"")
        endif()
    endif()
endif()

if(${INTERFACE} STREQUAL "COCOA")
    find_library(COCOA_LIBRARY Cocoa REQUIRED)
    find_package(OpenGL REQUIRED)
    target_link_libraries(garglk-common PUBLIC ${COCOA_LIBRARY} ${OPENGL_LIBRARIES})
else()
    set(QT_VERSION "6" CACHE STRING "Specify which major Qt version to use (5 or 6)")
    option(WITH_KDE "Use KDE Frameworks (improves discovery of a text editor for config file editing)" OFF)

    find_package(Qt${QT_VERSION} COMPONENTS Widgets REQUIRED CONFIG)
    target_link_libraries(garglk-common PRIVATE Qt${QT_VERSION}::Widgets)

    # QDBus exists on Windows, but almost nobody will be running DBus
    # there, so using QDBus would effectively just require shipping the
    # QDBus DLL for no gain.
    if(UNIX)
        find_package(Qt${QT_VERSION} COMPONENTS DBus CONFIG)
        if(Qt${QT_VERSION}DBus_FOUND)
            target_compile_definitions(garglk-common PRIVATE GARGLK_CONFIG_HAS_QDBUS)
            target_link_libraries(garglk-common PRIVATE Qt${QT_VERSION}::DBus)
        endif()
    endif()

    if(WITH_KDE)
        find_package(ECM 1.0.0 REQUIRED NO_MODULE)
        set(CMAKE_MODULE_PATH ${ECM_MODULE_PATH} ${ECM_KDE_MODULE_DIR})

        # This may trigger a warning about setting a more recent required CMake
        # version. Such a warning can be safely ignored. The newest KF versions
        # require a more recent version of CMake than Gargoyle does, but older
        # versions do not. If Gargoyle were to require the CMake version that
        # corresponds to the most recent KF version, systems with older
        # combinations of CMake and KF would be excluded, even though they work
        # just fine.
        find_package(KF${QT_VERSION} REQUIRED COMPONENTS KIO Service)
        target_link_libraries(garglk-common PRIVATE KF${QT_VERSION}::KIOWidgets KF${QT_VERSION}::Service)
        set_property(SOURCE sysqt.cpp APPEND PROPERTY COMPILE_DEFINITIONS GARGLK_CONFIG_KDE)
    endif()

    if(WITH_LAUNCHER)
        target_link_libraries(gargoyle PRIVATE Qt${QT_VERSION}::Widgets)
    endif()

    target_compile_definitions(garglk-common PRIVATE GARGLK_CONFIG_TICK)
    set(GARGLK_NEEDS_TICK TRUE CACHE INTERNAL "")
endif()

if("${SOUND}" STREQUAL "QT")
    find_package(Qt${QT_VERSION} COMPONENTS Multimedia REQUIRED CONFIG)
    if(MSVC)  # pkg-config on Windows does not work when cross-compiling for Windows-on-ARM
        find_library(SNDFILE sndfile REQUIRED)
        find_library(MPG123 NAMES mpg123 libmpg123 REQUIRED)
        find_library(OPENMPT NAMES openmpt libopenmpt REQUIRED)
        target_link_libraries(garglk-common PRIVATE Qt${QT_VERSION}::Multimedia ${SNDFILE} ${MPG123} ${OPENMPT})

        find_library(FLUIDSYNTH NAMES fluidsynth libfluidsynth)
        if(FLUIDSYNTH)
            target_compile_definitions(garglk-common PRIVATE GARGLK_HAS_FLUIDSYNTH)
            target_link_libraries(garglk-common PRIVATE ${FLUIDSYNTH})
        endif()
    else()  # regular compile (on Linux/Mac/...)
        find_package(PkgConfig REQUIRED)
        pkg_check_modules(SOUND REQUIRED IMPORTED_TARGET sndfile libmpg123 libopenmpt)
        target_link_libraries(garglk-common PRIVATE Qt${QT_VERSION}::Multimedia PkgConfig::SOUND)

        pkg_check_modules(FLUIDSYNTH IMPORTED_TARGET fluidsynth)
        if(TARGET PkgConfig::FLUIDSYNTH)
            target_compile_definitions(garglk-common PRIVATE GARGLK_HAS_FLUIDSYNTH)
            target_link_libraries(garglk-common PRIVATE PkgConfig::FLUIDSYNTH)
        endif()
    endif()
    target_sources(garglk-common PRIVATE sndqt.cpp)
elseif("${SOUND}" STREQUAL "SDL")
    find_package(PkgConfig REQUIRED)
    pkg_check_modules(SDL2 REQUIRED IMPORTED_TARGET sdl2 SDL2_mixer)
    target_link_libraries(garglk-common PRIVATE PkgConfig::SDL2)
    target_sources(garglk-common PRIVATE sndsdl.cpp)
    target_compile_definitions(garglk-common PRIVATE GARGLK_CONFIG_SDL)
else()
    target_sources(garglk-common PRIVATE sndnull.cpp)
    target_compile_definitions(garglk-common PRIVATE GARGLK_CONFIG_NO_SOUND)
endif()

if(NOT JPEGLIB STREQUAL "AUTO")
    set(JPEG_REQUIRED "REQUIRED")
endif()

if(JPEGLIB STREQUAL "AUTO" OR JPEGLIB STREQUAL "TURBO")
    find_package(PkgConfig ${JPEG_REQUIRED})
    if(PkgConfig_FOUND)
        pkg_check_modules(TURBO ${JPEG_REQUIRED} IMPORTED_TARGET libturbojpeg>=2.0)
        if(TARGET PkgConfig::TURBO)
            target_include_directories(garglk-common PRIVATE PkgConfig::TURBO)
            target_link_libraries(garglk-common PRIVATE PkgConfig::TURBO)
            target_compile_definitions(garglk-common PRIVATE GARGLK_CONFIG_JPEG_TURBO)
            set(GARGLK_FOUND_JPEG TRUE)
        endif()
    else()  # e.g. Windows-on-ARM cross-compilation
        find_library(TURBO NAMES turbojpeg libturbojpeg)
        if(NOT "${TURBO}" STREQUAL "TURBO-NOTFOUND")
            target_link_libraries(garglk-common PRIVATE ${TURBO})

=== terps/CMakeLists.txt ===
option(WITH_ADVSYS "Enable the advsys interpreter" ON)
option(WITH_AGILITY "Enable the agility interpreter" ON)
option(WITH_ALAN2 "Enable the alan2 interpreter" ON)
option(WITH_ALAN3 "Enable the alan3 interpreter" ON)
option(WITH_BOCFEL "Enable the bocfel interpreter" ON)
option(WITH_GIT "Enable the git interpreter" ON)
option(WITH_GLULXE "Enable the glulxe interpreter" ON)
option(WITH_HUGO "Enable the hugo interpreter" ON)
option(WITH_JACL "Enable the jacl interpreter" ON)
option(WITH_LEVEL9 "Enable the level9 interpreter" ON)
option(WITH_MAGNETIC "Enable the magnetic interpreter" ON)
option(WITH_PLUS "Enable the plus interpreter" ON)
option(WITH_SCARE "Enable the scare interpreter" ON)
option(WITH_SCOTT "Enable the scott interpreter" ON)
option(WITH_TADS "Enable the tads interpreter" ON)
option(WITH_TAYLOR "Enable the taylor interpreter" ON)

function(terp target)
    set(options POSIX LTO MATH WARNINGS GPL2)
    set(oneval CXXSTD)
    set(multival SRCS INCLUDE_DIRS MACROS LIBS)
    cmake_parse_arguments(TERP "${options}" "${oneval}" "${multival}" ${ARGN})

    add_executable(${target} WIN32 ${TERP_SRCS})
    set_target_properties(${target} PROPERTIES OUTPUT_NAME "${GARGLKPRE}${target}")
    target_compile_definitions(${target} PRIVATE GARGLK ${TERP_MACROS})
    target_include_directories(${target} PRIVATE ${TERP_INCLUDE_DIRS})
    target_link_libraries(${target} PRIVATE garglkmain ${TERP_LIBS})

    if(TERP_GPL2)
        target_link_libraries(${target} PRIVATE garglk-gpl2)
    else()
        target_link_libraries(${target} PRIVATE garglk)
    endif()

    if(WIN32)
        target_sources(${target} PRIVATE "${PROJECT_SOURCE_DIR}/garglk/icons.rc" "${PROJECT_SOURCE_DIR}/terps/garglk.manifest")
    endif()

    if(NOT TERP_CXXSTD)
        set(TERP_CXXSTD 98)
    endif()

    c_standard(${target} 11)
    cxx_standard(${target} ${TERP_CXXSTD})

    if(TERP_POSIX)
        target_compile_definitions(${target} PRIVATE $<$<COMPILE_LANGUAGE:C>:_XOPEN_SOURCE=600>)
    endif()
    if(TERP_LTO)
        lto(${target})
    endif()
    if(TERP_MATH AND NOT MSVC)
        target_link_libraries(${target} PRIVATE m)
    endif()
    if(TERP_WARNINGS)
        warnings(${target})
    endif()
    if(DIST_INSTALL)
        install(TARGETS ${target} DESTINATION "${PROJECT_SOURCE_DIR}/build/dist")
    elseif(UNIX)
        install(TARGETS ${target} DESTINATION "${INTERPRETER_INSTALL_DIR}")
    endif()
endfunction()

# Ideally CMake would allow multiple identical calls to add_subdirectory, but it
# doesn't, so ensure they're called only once, if needed.
if(WITH_PLUS OR WITH_SCOTT OR WITH_TAYLOR)
    add_subdirectory(c64diskimage)
endif()

if(WITH_SCOTT OR WITH_TAYLOR)
    add_subdirectory(unp64)
endif()

if(CMAKE_VERSION VERSION_LESS "3.20")
    include(TestBigEndian)
    test_big_endian(GARGLK_BIG_ENDIAN)
else()
    if(CMAKE_C_BYTE_ORDER STREQUAL "BIG_ENDIAN")
        set(GARGLK_BIG_ENDIAN ON)
    endif()
endif()

# ------------------------------------------------------------------------------
#
# AdvSys 1.2 + ANSI + NewParser + parts of glkize
#
if(WITH_ADVSYS)
    terp(advsys
        SRCS advsys/advmsg.c advsys/advtrm.c advsys/advprs.c
        advsys/advdbs.c advsys/advint.c advsys/advjunk.c advsys/advexe.c
        advsys/glkstart.c)

    if(CMAKE_C_COMPILER_ID MATCHES "Clang$")
        # This is a style choice in the code.
        target_compile_options(advsys PRIVATE "-Wno-parentheses")
    endif()
endif()

# ------------------------------------------------------------------------------
#
# Agility 1.1.2 with Glk
#
# Agility uses some bad voodoo to get filenames back from glk filerefs.
# We have three options:
#   1) use the bad voodoo (only works on unixes)
#   2) don't use glk file prompts (GLK_ANSI_ONLY)
#   3) use garglk extension garglk_fileref_get_name (GARGLK)
#
if(WITH_AGILITY)
    terp(agility
        SRCS agility/agtread.c agility/gamedata.c agility/util.c
        agility/agxfile.c agility/auxfile.c agility/filename.c agility/parser.c
        agility/exec.c agility/runverb.c agility/metacommand.c agility/savegame.c
        agility/debugcmd.c agility/agil.c agility/token.c agility/disassemble.c
        agility/object.c agility/interface.c agility/os_glk.c
        MACROS GLK POSIX
        GPL2)
endif()

# ------------------------------------------------------------------------------
#
# Alan interpreter 2.8.6
#
# Fixed a couple of bugs (needsp needs resetting in a few places).
# Added glk file prompts for gargoyle using garglk_fileref_get_name.
#
if(WITH_ALAN2)
    set(ALAN2_MACROS GLK)

    if(NOT GARGLK_BIG_ENDIAN)
        list(APPEND ALAN2_MACROS REVERSED)
    endif()

    terp(alan2
        SRCS alan2/arun.c alan2/main.c alan2/debug.c alan2/args.c alan2/exe.c
        alan2/inter.c alan2/parse.c alan2/rules.c alan2/stack.c alan2/decode.c
        alan2/term.c alan2/reverse.c alan2/readline.c alan2/params.c
        alan2/sysdep.c alan2/glkstart.c alan2/glkio.c alan2/alan.version.c
        MACROS ${ALAN2_MACROS}
        POSIX)

    if(CMAKE_C_COMPILER_ID MATCHES "Clang$")
        # This is a style choice in the code.
        target_compile_options(alan2 PRIVATE "-Wno-dangling-else")
    endif()
endif()

# ------------------------------------------------------------------------------
#
# Alan interpreter 3.0beta8
#
if(WITH_ALAN3)
    terp(alan3
        SRCS alan3/alan.version.c alan3/act.c alan3/actor.c alan3/args.c
        alan3/arun.c alan3/attribute.c alan3/checkentry.c alan3/class.c
        alan3/converter.c alan3/current.c alan3/debug.c alan3/decode.c
        alan3/dictionary.c alan3/event.c alan3/exe.c alan3/fnmatch.c
        alan3/glkio.c alan3/glkstart.c alan3/instance.c alan3/inter.c
        alan3/lists.c alan3/literal.c alan3/main.c alan3/memory.c alan3/msg.c
        alan3/options.c alan3/output.c alan3/params.c alan3/parse.c
        alan3/readline.c alan3/reverse.c alan3/rules.c alan3/save.c alan3/scan.c
        alan3/score.c alan3/set.c alan3/stack.c alan3/state.c alan3/syntax.c
        alan3/sysdep.c alan3/syserr.c alan3/term.c alan3/types.c alan3/utils.c
        alan3/word.c alan3/compatibility.c alan3/AltInfo.c alan3/Container.c
        alan3/Location.c alan3/ParameterPosition.c alan3/StateStack.c
        MACROS GLK HAVE_GARGLK BUILD=0
        POSIX)
endif()

# ------------------------------------------------------------------------------
#
# Bocfel 2.5
#
if(WITH_BOCFEL)
    set(BOCFEL_MACROS ZTERP_GLK ZTERP_GLK_BLORB ZTERP_GLK_UNIX "ZTERP_STATIC_PATCH_FILE=\"static-patches.h\"")
    if(UNIX)
        list(APPEND BOCFEL_MACROS ZTERP_OS_UNIX)
    elseif(WIN32)
        list(APPEND BOCFEL_MACROS ZTERP_OS_WIN32)
    endif()

    if(GARGLK_NEEDS_TICK)
        list(APPEND BOCFEL_MACROS ZTERP_GLK_TICK)
    endif()

    terp(bocfel
        SRCS bocfel/blorb.cpp bocfel/branch.cpp bocfel/dict.cpp bocfel/iff.cpp
        bocfel/io.cpp bocfel/mathop.cpp bocfel/meta.cpp bocfel/memory.cpp bocfel/objects.cpp
        bocfel/options.cpp bocfel/osdep.cpp bocfel/patches.cpp bocfel/process.cpp
        bocfel/random.cpp bocfel/screen.cpp bocfel/sound.cpp bocfel/stack.cpp
        bocfel/stash.cpp bocfel/unicode.cpp bocfel/util.cpp bocfel/zterp.cpp
        bocfel/glkstart.cpp bocfel/glkautosave.cpp
        CXXSTD 14
        MACROS ${BOCFEL_MACROS}
        LTO WARNINGS)

    if(CMAKE_C_COMPILER_ID MATCHES "GNU$")
        target_compile_options(bocfel PRIVATE "-Wno-sign-compare")
    endif()
endif()

# ------------------------------------------------------------------------------
#
# Git 1.3.8
#
# Reworked startup code to redirect errors to Glk windows.
#
if(WITH_GIT)
    set(GIT_MACROS USE_INLINE)

    if(GARGLK_NEEDS_TICK)
        list(APPEND GIT_MACROS GIT_NEED_TICK)
    endif()

    if(GARGLK_BIG_ENDIAN)
        list(APPEND GIT_MACROS USE_BIG_ENDIAN)
    endif()

    terp(git
        SRCS git/git.c git/memory.c git/compiler.c git/opcodes.c git/operands.c
        git/peephole.c git/terp.c git/glkop.c git/search.c git/git_unix.c
        git/savefile.c git/saveundo.c git/gestalt.c git/heap.c git/accel.c
        MACROS ${GIT_MACROS}
        MATH)
endif()

# ------------------------------------------------------------------------------
#
# Glulxe 0.6.1
#
if(WITH_GLULXE)
    set(GLULXE_MACROS FLOAT_COMPILE_SAFER_POWF)
    if(APPLE)
        list(APPEND GLULXE_MACROS OS_MAC)
        # _DARWIN_C_SOURCE for arc4random().
        set_source_files_properties(glulxe/osdepend.c PROPERTIES COMPILE_DEFINITIONS _DARWIN_C_SOURCE)
    elseif(UNIX)
        list(APPEND GLULXE_MACROS OS_UNIX)
        if(CMAKE_SYSTEM_NAME STREQUAL "Linux")
            list(APPEND GLULXE_MACROS UNIX_RAND_GETRANDOM)
        endif()
    elseif(WIN32)
        list(APPEND GLULXE_MACROS OS_WINDOWS)
    endif()

    terp(glulxe
        SRCS glulxe/main.c glulxe/files.c glulxe/vm.c glulxe/exec.c
        glulxe/funcs.c glulxe/operand.c glulxe/string.c glulxe/glkop.c
        glulxe/heap.c glulxe/serial.c glulxe/search.c glulxe/gestalt.c
        glulxe/osdepend.c glulxe/unixstrt.c glulxe/accel.c glulxe/profile.c
        glulxe/float.c
        MACROS ${GLULXE_MACROS}
        MATH
        POSIX
        LTO)
endif()

# ------------------------------------------------------------------------------
#
# Hugo for Unix git-df0ce19
#
if(WITH_HUGO)
    terp(hugo
        SRCS hugo/heglk/heglk.c hugo/heglk/heglkunix.c hugo/source/he.c
        hugo/source/hemisc.c hugo/source/heparse.c hugo/source/herun.c
        hugo/source/heexpr.c hugo/source/heobject.c hugo/source/heres.c
        hugo/source/heset.c hugo/source/stringfn.c
        INCLUDE_DIRS hugo/source
        MACROS GLK HUGO_GLKUNIX COMPILE_V25 NO_KEYPRESS_CURSOR "HUGO_INLINE=static inline")
endif()

# ------------------------------------------------------------------------------
#
# JACL git-ce6517f
#
if(WITH_JACL)
    terp(jacl
        SRCS jacl/jacl.c jacl/glk_startup.c jacl/findroute.c jacl/interpreter.c
        jacl/loader.c jacl/glk_saver.c jacl/logging.c jacl/parser.c
        jacl/display.c jacl/utils.c jacl/jpp.c jacl/resolvers.c jacl/errors.c
        jacl/encapsulate.c jacl/libcsv.c
        MACROS GLK
        MATH
        POSIX
        GPL2)

    if(CMAKE_C_COMPILER_ID MATCHES "Clang$")
        # This is a style choice in the code.
        target_compile_options(jacl PRIVATE "-Wno-parentheses-equality")

        # Non-prototype (K&R) declarations have been fixed in JACL's Git
        # repository, but there hasn't been a release yet since then, so
        # just ignore the warnings here; remove in the future when a new
        # JACL is upstreamed.
        target_compile_options(jacl PRIVATE "-Wno-deprecated-non-prototype")
    endif()
endif()

# ------------------------------------------------------------------------------
#
# Level9 5.2
#
# Disabled the status bar that just contained a static version string.
# Added graphics support.
#
if(WITH_LEVEL9)
    terp(level9
        SRCS level9/Glk/glk.c level9/bitmap.c level9/level9.c
        INCLUDE_DIRS level9
        MACROS PRIVATE BITMAP_DECODER NEED_STRICMP_PROTOTYPE
        stricmp=gln_strcasecmp strnicmp=gln_strncasecmp
        MATH)

    if(CMAKE_C_COMPILER_ID MATCHES "Clang$")
        # This is a style choice in the code.
        target_compile_options(level9 PRIVATE "-Wno-switch")
    endif()
endif()

# ------------------------------------------------------------------------------
#
# Magnetic 2.3.1
#
# Disable layered drawing, because that is slower than drawing
# all the pixels with fill_rect -- the opposite of Xglk.
#
# Delay opening the status window, because for games that don't use it
# magnetic shows a static version string only. I don't like that.
#
# Made shaded border around pictures if-defable.
#
if(WITH_MAGNETIC)
    terp(magnetic
        SRCS magnetic/Generic/emu.c magnetic/Glk/glk.c
        INCLUDE_DIRS magnetic/Generic
        MACROS MAGNETIC_GLKUNIX)

    if(CMAKE_C_COMPILER_ID MATCHES "Clang$")
        # The alternative to this is lots of casts; ignore this warning

=== support/hqx/CMakeLists.txt ===
# hqx 1.2

add_library(hqx STATIC hq2x.c hq3x.c hq4x.c init.c)

set_property(TARGET hqx PROPERTY POSITION_INDEPENDENT_CODE TRUE)

# Clang warns that passing a uint32_t to abs() has no effect, which is
# not true: on systems with 32-bit int, any value in a uint32_t greater
# than 0x7fffffff will be converted to a negative value when it's passed
# in, and then rendered positive: for example, 0xffffffff will convert
# to -1, and be returned as 1. The call is dodgy because it expects int
# to be 32 bits (which is probable), and wrap around as in 2's
# complement (which is all but guaranteed); but it's probably going to
# work, and the warning is unnecessary.
if(CMAKE_C_COMPILER_ID STREQUAL "Clang")
    target_compile_options(hqx PRIVATE -Wno-absolute-value)
endif()

target_include_directories(hqx PUBLIC ${CMAKE_CURRENT_SOURCE_DIR})

=== support/xbrz-null/CMakeLists.txt ===
# xBRZ dummy interface

add_library(xbrz-null OBJECT xbrz.cpp)

cxx_standard(xbrz-null 17)

set_property(TARGET xbrz-null PROPERTY POSITION_INDEPENDENT_CODE TRUE)

target_include_directories(xbrz-null PUBLIC ../xbrz)

=== support/xbrz/CMakeLists.txt ===
# xBRZ 1.8

add_library(xbrz OBJECT xbrz.cpp)

cxx_standard(xbrz 17)

set_property(TARGET xbrz PROPERTY POSITION_INDEPENDENT_CODE TRUE)

target_include_directories(xbrz PUBLIC ${CMAKE_CURRENT_SOURCE_DIR})

=== terps/unp64/CMakeLists.txt ===
add_library(unp64 STATIC 6502_emu.cpp exo_util.cpp globals.cpp unp64.cpp
    scanners/scanners.cpp scanners/abuze_crunch.cpp scanners/action_packer.cpp
    scanners/byte_boiler.cpp scanners/caution.cpp scanners/ccs.cpp scanners/cruel.cpp
    scanners/eca.cpp scanners/exomizer.cpp scanners/expert.cpp scanners/final_super_comp.cpp
    scanners/intros.cpp scanners/master_compressor.cpp scanners/megabyte.cpp scanners/mr_cross.cpp
    scanners/mr_z.cpp scanners/pu_crunch.cpp scanners/section8.cpp scanners/tbc_multicomp.cpp
    scanners/tcs_crunch.cpp scanners/time_cruncher.cpp scanners/xtc.cpp)

target_include_directories(unp64 INTERFACE ${CMAKE_CURRENT_SOURCE_DIR} PRIVATE PARENT_DIR ${CMAKE_CURRENT_SOURCE_DIR})

cxx_standard(unp64 ${CXX_VERSION})
warnings(unp64)

=== terps/tads/glk/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.13)

project(TADS)

# Add sources to a target from a specified directory
function(add_sources target dir)
    cmake_parse_arguments(PARSE_ARGV 2 ADD "" "" "SRCS")
    list(TRANSFORM ADD_SRCS PREPEND ${dir})
    target_sources(${target} PRIVATE ${ADD_SRCS})
endfunction()

# Find the requested library
set(GlkLibPath "glk" CACHE PATH "Glk Library Path")
set(GlkLibName "" CACHE STRING "Glk Library Name (without lib- or -.a)")
if (GlkLibName STREQUAL "")
    get_filename_component(GlkLibNameReal ${GlkLibPath} NAME)
else ()
    set(GlkLibNameReal ${GlkLibName} STRING)
endif()
add_library(glk STATIC IMPORTED)
set_target_properties(glk PROPERTIES IMPORTED_LOCATION "${GlkLibPath}/lib${GlkLibNameReal}.a")
target_include_directories(glk INTERFACE ${GlkLibPath})

add_executable(tadsr)
target_link_libraries(tadsr glk)
target_include_directories(tadsr PRIVATE . ../tads2/ ../tads3/)
add_sources(tadsr "./"
    SRCS memicmp.c osbuffer.c osextra.c osglk.c osglkban.c osmisc.c osparse.c
    osportable.cc t23run.cpp t2askf.c t2indlg.c t3askf.cpp t3indlg.cpp vmuni_cs.cpp)
add_sources(tadsr "../tads2/"
    SRCS argize.c bif.c bifgdum.c cmap.c cmd.c dat.c dbgtr.c errmsg.c execmd.c
    fio.c fioxor.c getstr.c ler.c linfdum.c lst.c mch.c mcm.c mcs.c obj.c oem.c
    os0.c oserr.c osifc.c osnoui.c osrestad.c osstzprs.c ostzposix.c out.c output.c
    ply.c qas.c regex.c run.c runstat.c suprun.c trd.c voc.c vocab.c)
add_sources(tadsr "../tads3/"
    SRCS charmap.cpp md5.cpp resldexe.cpp resload.cpp sha2.cpp std.cpp tcerr.cpp
    tcerrmsg.cpp tcgen.cpp tcglob.cpp tcmain.cpp tcprs.cpp tcprs_rt.cpp tcprsnf.cpp
    tcprsnl.cpp tcprsstm.cpp tcsrc.cpp tct3.cpp tct3_d.cpp tct3nl.cpp tct3stm.cpp
    tct3unas.cpp tctok.cpp utf8.cpp vmanonfn.cpp vmbif.cpp vmbifl.cpp vmbifreg.cpp
    vmbift3.cpp vmbiftad.cpp vmbiftio.cpp vmbignum.cpp vmbignumlib.cpp vmbt3_nd.cpp
    vmbytarr.cpp vmcfgmem.cpp vmcoll.cpp vmconhmp.cpp vmconsol.cpp vmcrc.cpp
    vmcset.cpp vmdate.cpp vmdict.cpp vmdynfunc.cpp vmerr.cpp vmerrmsg.cpp
    vmfile.cpp vmfilnam.cpp vmfilobj.cpp vmfref.cpp vmfunc.cpp vmglob.cpp
    vmgram.cpp vmhash.cpp vmhostsi.cpp vmhosttx.cpp vmimage.cpp vmimg_nd.cpp
    vmini_nd.cpp vminit.cpp vminitim.cpp vmintcls.cpp vmisaac.cpp vmiter.cpp
    vmlog.cpp vmlookup.cpp vmlst.cpp vmmain.cpp vmmcreg.cpp vmmeta.cpp
    vmnetfillcl.cpp vmobj.cpp vmop.cpp vmpack.cpp vmpat.cpp vmpool.cpp
    vmpoolim.cpp vmregex.cpp vmrun.cpp vmrunsym.cpp vmsa.cpp vmsave.cpp vmsort.cpp
    vmsortv.cpp vmsrcf.cpp vmstack.cpp vmstr.cpp vmstrbuf.cpp vmstrcmp.cpp
    vmtmpfil.cpp vmtobj.cpp vmtype.cpp vmtypedh.cpp vmtz.cpp vmtzobj.cpp
    vmundo.cpp vmvec.cpp vmconnom.cpp)
set_property(TARGET tadsr PROPERTY CXX_STANDARD 11)
target_compile_definitions(tadsr PRIVATE GLK GLK_TIMERS GLK_UNICODE TC_TARGET_T3 RUNTIME VMGLOB_STRUCT)
if(MINGW32)
    target_compile_definitions(tadsr PRIVATE DMSDOS DT_WIN32)
endif()
if("${CMAKE_C_COMPILER_ID}" STREQUAL "Clang")
    # This is a style choice in the code.
    target_compile_options(tadsr PRIVATE -Wno-deprecated-register -Wno-logical-not-parentheses -Wno-pointer-sign -Wno-string-concatenation)
endif()

=== terps/frankendrift/FrankenDrift.GlkRunner/FrankenDrift.GlkRunner.Gargoyle/CMakeLists.txt ===
find_program(DOTNET dotnet)
if(NOT DOTNET)
    message(FATAL_ERROR "FrankenDrift requires the .NET SDK (missing \"dotnet\")")
endif()

if(CMAKE_SYSTEM_NAME STREQUAL "Linux")
    set(GARGLK_DOTNET_RID "linux")
elseif(WIN32)
    set(GARGLK_DOTNET_RID "win")
    set(GARGLK_FRANKEN_EXT ".exe")
elseif(CMAKE_SYSTEM_NAME STREQUAL "Darwin")
    set(GARGLK_DOTNET_RID "osx")
elseif(CMAKE_SYSTEM_NAME STREQUAL "FreeBSD")
    set(GARGLK_DOTNET_RID "freebsd")
else()
    message(FATAL_ERROR "FrankenDrift is currently not supported on this platform")
endif()

# Cannot cross-compile FrankenDrift for another OS ...
if(NOT CMAKE_SYSTEM_NAME STREQUAL CMAKE_HOST_SYSTEM_NAME)
    message(FATAL_ERROR "Cross-compiling to another OS is not supported for FrankenDrift.")
endif()

# ... but CAN cross-compile for a different CPU architecture:
if(CMAKE_SYSTEM_PROCESSOR MATCHES "^(x86_64|AMD64|x64|amd64)$")
    set(GARGLK_DOTNET_RID "${GARGLK_DOTNET_RID}-x64")
elseif(CMAKE_SYSTEM_PROCESSOR MATCHES "^(ARM64|arm64|aarch64|armv8l)$")
    set(GARGLK_DOTNET_RID "${GARGLK_DOTNET_RID}-arm64")
else()
    message(FATAL_ERROR "Unsupported CPU architecture for FrankenDrift: ${CMAKE_SYSTEM_PROCESSOR}")
endif()

if(APPLE)
    set(GARGLK_FRANKEN_DYLIB "${CMAKE_BINARY_DIR}/garglk/libgarglk.dylib")
elseif(WIN32)
    set(GARGLK_FRANKEN_DYLIB "${CMAKE_BINARY_DIR}/garglk/garglk.lib")
else()
    set(GARGLK_FRANKEN_DYLIB "${CMAKE_BINARY_DIR}/garglk/libgarglk.so")
endif()

add_custom_target(frankendrift
    ALL
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
    COMMAND ${CMAKE_COMMAND} -E copy "${GARGLK_FRANKEN_DYLIB}" "${CMAKE_CURRENT_SOURCE_DIR}"
    COMMAND ${DOTNET} publish --self-contained -c Release -r "${GARGLK_DOTNET_RID}" -p:GarglkMode=dynamic "-p:BaseIntermediateOutputPath=${CMAKE_CURRENT_BINARY_DIR}/obj/" "-p:BaseOutputPath=${CMAKE_CURRENT_BINARY_DIR}/bin/" -o "${CMAKE_CURRENT_BINARY_DIR}"
    COMMENT "Building FrankenDrift with ${DOTNET}"
)

get_filename_component(GARGLK_FRANKEN_DYLIB_NAME "${GARGLK_FRANKEN_DYLIB}" NAME)
add_custom_command(TARGET frankendrift
    POST_BUILD
    COMMAND ${CMAKE_COMMAND} -E rm "${CMAKE_CURRENT_SOURCE_DIR}/${GARGLK_FRANKEN_DYLIB_NAME}"
)

if(WIN32)
    # ensure that FrankenDrift gets proper HiDpi support on Windows by embedding the necessary manifest
    add_custom_command(TARGET frankendrift
        POST_BUILD
        COMMAND "mt.exe" -nologo -manifest "${PROJECT_SOURCE_DIR}/terps/garglk.manifest" "-updateresource:${CMAKE_CURRENT_BINARY_DIR}/FrankenDrift.GlkRunner.Gargoyle.exe"
        COMMENT "Adding FrankenDrift Manifest file"
    )
endif()

add_dependencies(frankendrift garglk)

if(DIST_INSTALL)
    install(PROGRAMS "${CMAKE_CURRENT_BINARY_DIR}/FrankenDrift.GlkRunner.Gargoyle${GARGLK_FRANKEN_EXT}" DESTINATION "${PROJECT_SOURCE_DIR}/build/dist")
else()
    install(PROGRAMS "${CMAKE_CURRENT_BINARY_DIR}/FrankenDrift.GlkRunner.Gargoyle${GARGLK_FRANKEN_EXT}" DESTINATION "${INTERPRETER_INSTALL_DIR}")
endif()

=== debian/changelog ===
gargoyle-free (2026.1.1+dfsg-1) unstable; urgency=medium

  * New upstream version 2023.1+dfsg
  * Disable useless Salsa CI jobs
  * Bump Standards-Version to 4.7.3, drop Priority: tag
  * New upstream version 2026.1.1+dfsg
  * Copyright review: there is a new FrankenDrift engine,
    but this is DotNet / Windows only
  * Refresh patches
  * Add build-dep on libturbojpeg0-dev

 -- Alexandre Detiste <tchet@debian.org>  Fri, 27 Feb 2026 12:04:03 +0100

=== debian/control ===
Source: gargoyle-free
Section: games
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders:
 Sylvain Beucler <beuc@debian.org>,
 Alexandre Detiste <tchet@debian.org>,
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 libfmt-dev,
 libfontconfig-dev,
 libfreetype-dev,
 libjpeg-dev,
 libpng-dev,
 libsdl2-dev,
 libsdl2-mixer-dev,
 libspeechd-dev,
 libturbojpeg0-dev,
 pkgconf,
 qt6-base-dev,
 qt6-tools-dev,
Standards-Version: 4.7.3
Homepage: https://ccxvii.net/gargoyle/
Vcs-Git: https://salsa.debian.org/games-team/gargoyle-free.git
Vcs-Browser: https://salsa.debian.org/games-team/gargoyle-free
X-Style: black

Package: gargoyle-free
Architecture: any
Depends:
 fonts-go,
 fonts-sil-charis,
 ${misc:Depends},
 ${shlibs:Depends},
Provides:
 tads2-interpreter,
 tads3-interpreter,
 zcode-interpreter,
Description: graphical player for Interactive Fiction games
 Gargoyle is an Interactive Fiction (text adventure) player that
 supports all the major interactive fiction formats.
 .
 Most interactive fiction is distributed as portable game files. These
 portable game files come in many formats. In the past, you used to
 have to download a separate player (interpreter) for each format of
 IF you wanted to play. Instead, Gargoyle provides unified player.
 .
 Gargoyle is based on the standard interpreters for the formats it
 supports: .taf (Adrift games, played with Scare), .dat (AdvSys),
 *.agx/.d$$ (AGiliTy), .a3c (Alan3), .asl/.cas (Quest games, played
 with Geas), .jacl/.j2 (JACL), .l9/.sna (Level 9), .mag (Magnetic),
 *.saga (Scott Adams Grand Adventures), .gam/.t3 (TADS),
 *.z1/.z2/.z3/.z4/.z5/.z6/.z7/.z8 (Inform Z-Machine games, played with
 Frotz, Nitfol or Bocfel), .ulx/.blb/.blorb/.glb/.gblorb (Inform or
 Superglús games compiled to the Glulxe VM in Blorb archives, played
 with Git or Glulxe), .zlb, .zblorb (Inform Z-Machine games in Blorb
 archives, played with Frotz).
 .
 (note: do not confuse the Git Glux interpreter with the Git DVCS or
 the GNU Interactive Tools)
 .
 Gargoyle also features graphics, sounds and Unicode support.
 .
 Technically all the bundled interpreters support the Glk API to
 manage I/O (keyboard, graphics, sounds, file) in IF games. Gargoyle
 provides a Glk implementation called garglk that displays texts and
 images in a graphical Qt window, with care on typography.
 .
 Limitations:
 .
 * While Gargoyle can display in-game pictures, it does not provide a
 way to display the cover art present in some Blorb archives.
 .
 * The TADS interpreter doesn't support HTML TADS; you can play
 the games, but will miss the hyperlinks.
